package brownstrategy;

import game.Game;
import game.Strategy;

import java.util.Random;
import java.util.StringTokenizer;

import util.Array;

import brownstrategy.agent.Agent;
import brownstrategy.agent.DeterministicAgent;
import brownstrategy.agent.NondeterministicAgent;

/**
 * 
 * This agent plays by multiplying everyones
 * moves from the previous round mod 12
 * 
 * @author jberg
 *
 */
public class BrownConstantStrategy extends NondeterministicAgent {
	
	int action;
	double[] arr;

	public BrownConstantStrategy(Game g, long seed, String options) {
		super(g,seed,options);
		StringTokenizer st = new StringTokenizer(options, ",");
		if (st.hasMoreTokens()) {
			st.nextToken();
			if (st.hasMoreTokens()) {
				action = Integer.parseInt(st.nextToken());
			}
			else {
				action = random.nextInt(g.getNumActions());
			}
		}
		else {
			action = random.nextInt(g.getNumActions());
		}
		arr = new double[g.getNumActions()];
		arr[action] = 1;
	}
	
	@Override
	public double[] getActionDistribution() {
		return arr;
	}
	
	public String toString() {
		return "Constant " + action;
	}

	@Override
	public Agent getCopy() {
		return new BrownConstantStrategy(_g, _seed, _options);
	}

	@Override
	public Agent getCopy(Game g, long seed, String options) {
		return new BrownConstantStrategy(g, seed, options);
	}

	@Override
	public void observeOutcome(int[] actions) {
		//nothing to do here
	}
	
	@Override
	public void lookAhead(int[] actions) {
		//nothing to do here
	}

	@Override
	public void lookBack() {
		//nothing to do here
	}

}
