package ca.ualberta.cs.shamooshak;

class SequencePredictor extends Predictor
{
  boolean equal(int[][] action, int x, int y)
  {
    if ((action[x][1] - action[x][0] + 12) % 12 == (action[y][1] - action[y][0] + 12) % 12)
      return false;
    if ((action[x][2] - action[x][0] + 12) % 12 == (action[y][2] - action[y][0] + 12) % 12)
      return false;
    if ((action[(x + 1)][0] - action[x][0] + 12) % 12 == (action[(y + 1)][0] - action[y][0] + 12) % 12)
      return false;
    if ((action[(x + 1)][1] - action[x][0] + 12) % 12 == (action[(y + 1)][1] - action[y][0] + 12) % 12) {
      return false;
    }
    return (action[(x + 1)][2] - action[x][0] + 12) % 12 != (action[(y + 1)][2] - action[y][0] + 12) % 12;
  }

  void predict(double[][] output, int[][] action, int actionCounter)
  {
    for (int i = 0; i < 2; i++) {
      for (int j = 0; j < 12; j++)
        output[i][j] = 0.0D;
    }
    double betaprim = 0.0D;
    for (int i = 0; i < actionCounter - 2; i++)
      if (equal(action, i, actionCounter - 2)) {
        for (int player = 0; player < 2; player++)
          for (int j = 0; j < 12; j++)
            output[player][j] *= betaprim;
        for (int player = 0; player < 2; player++)
          output[player][action[(i + 2)][player]] += 1.0D - betaprim;
        betaprim = Shamooshak.beta;
      }
  }
}