#!/usr/bin/perl 

use File::Find;


my $LSG_VERSION=$ENV{"LSG_VERSION"};

my @fileArray = ();

sub appendToArray(){
  if ($_=~/\.java$/){
    push(@fileArray,$File::Find::name);
  }
} 

sub getJavaFiles{
  my $directory = shift(@_);
  @fileArray = ();
  find(\&appendToArray,($directory));
  my $result = join(' ',@fileArray);
  @fileArray = ();
  $result;
}

my $libdir="lib";

sub compileBot{
  my $directory = shift(@_);
  my $libname = shift(@_);
  print "Compiling $directory\n";
  if (!(-e "$directory/bin")){
    mkdir "$directory/bin";
  }
  my $ sourceFiles = getJavaFiles("$directory/src");
  system("javac -cp $directory/src:$libdir/lemonade$LSG_VERSION.jar $sourceFiles -d $directory/bin 2>> error.txt");
  if (-e "$directory/data"){
    system("cp -rf $directory/data/* $directory/bin");
  }
  system("jar -cf $libdir/$libname -C $directory/bin .");
}

sub cleanBot{
  my $directory = shift(@_);
  my $libname = shift(@_);
  print "Cleaning $directory\n";
  system("rm -rf $directory/bin");
  system("rm -rf $libdir/$libname");
}

my %bots2012 = (
  "wrapper"=>"wrapper2012.jar",
  "Wunder"=>"rutgers2012.jar",
  "Taha"=>"taha2012.jar",
  "Chapman"=>"chapman2012.jar"
);

my %bots2011 = (
  "Bowling"=>"bowling2011.jar",
  "JerseyBeachcomber"=>"jerseybeachcomber.jar", 
  "BMJoe"=>"BMJoe.jar",
  "Brown"=>"brown2011.jar",
  "Chan"=>"chan.jar",
  "Chapman"=>"chapman2011.jar",
  "MacDermed"=>"macdermed2011.jar",
  "Pujara"=>"pujara2011.jar"
);

my %bots2010 = (
  "arizona"=>"arizona2010.jar",
  "MacDermed"=>"MatchMate.jar", 
  "UP"=>"UP2010.jar", 
  "arizona"=>"arizona2010.jar", 
  "brown"=>"brown2010.jar", 
  "jpujara"=>"pujara2010.jar", 
  "shamooshak"=>"ShamooShak2010.jar", 
  "waugh"=>"waugh2010.jar",
  "rutgers"=> "RL32010.jar", 
  "meta"=>"meta2010.jar",
  "Morrill"=>"Morrill2010.jar"
);

my %bots2009 = (
"Chapman"=>"Chapman.jar",
"frozenpontiac"=>"FrozenPontiac.jar",
"Kuhlmann"=>"Kuhlmann.jar",
"Lebiere"=>"ACTR.jar",
"Pujara"=>"Pujara.jar",
"RL3"=>"RL3.jar",
"Schapire"=>"Schapire.jar",
"Waugh"=>"waugh.jar",
"brown"=>"brown.jar"
);

sub compileBots{
  my $botRef = shift(@_);
  my $dir = shift(@_);
  my %bots = %{$botRef};
  while(my ($directory,$libname) = each(%bots)){
    my $fullDir = $dir.$directory;
    compileBot($fullDir,$libname);
  }
}

sub cleanBots{
  my $botRef = shift(@_);
  my $dir = shift(@_);
  my %bots = %{$botRef};
  while(my ($directory,$libname) = each(%bots)){
    my $fullDir = $dir.$directory;
    cleanBot($fullDir,$libname);
  }
}

sub compile2009{
  compileBots(\%bots2009,"2009/");
}

sub clean2009{
  cleanBots(\%bots2009,"2009/");
}

sub clean2010{
  cleanBots(\%bots2010,"2010/");
}

sub compile2010{
  compileBots(\%bots2010,"2010/");
}

sub clean2011{
  cleanBots(\%bots2011,"2011/");
}

sub compile2011{
  compileBots(\%bots2011,"2011/");
}
sub clean2012{
  cleanBots(\%bots2012,"2012/");
}

sub compile2012{
  compileBots(\%bots2012,"2012/");
}

1;

