package analysis;
import java.util.Random;


public class AsymmetricGameGenerator implements GameGeneratorInterface{
  private boolean symmetricDistribution;





  public AsymmetricGameGenerator(int maxValue, boolean symmetricDistribution, 
      UtilityDistribution utilityDistributionType) {
    this.maxValue = maxValue;
    this.symmetricDistribution = symmetricDistribution;
    this.utilityDistributionType = utilityDistributionType;
  }

  int maxValue;
  
  UtilityDistribution utilityDistributionType;

  

  
  
  public void shuffle(int[] array, Random r){
    for(int i=0;i<array.length;i++){
      int target = r.nextInt(array.length-i)+i;
      if (target>i){
        final int temp=array[target];
        array[target]=array[i];
        array[i]=temp;
      }
    }
  }
  
  
    
  public void generateRandomUtilities(int[] values, Random r){
    utilityDistributionType.generateUtilities(values, maxValue, r);

  }
  
  
  
  public void generateUniqueActions(ThreePlayerGame g, Random r, int numActions){
    
    for(int i=0;i<numActions;i++){
      for(int j=0;j<numActions;j++){
        for(int k=0;k<numActions;k++){
          int[] values = g.getUtility(i, j, k);
          generateRandomUtilities(values,r);
          if (symmetricDistribution){
            shuffle(values,r);
          }
        }
      }
    }
  }
  

  public ThreePlayerGame generateGame(Random r, int numActions){
    ThreePlayerGame g = new ThreePlayerGame(numActions);
    for(int i=0;i<numActions;i++){
      for(int j=0;j<numActions;j++){
        for(int k=0;k<numActions;k++){
          int[] values = g.getUtility(i, j, k);
          generateRandomUtilities(values,r);
          if (symmetricDistribution){
            shuffle(values,r);
          }
        }
      }
    }
    return g;
  }
}
