package analysis;

/**
 * WARNING: ASSUMES SYMMETRY
 * Tests if there is an action for player 1 and an action for player 2, such that
 * player 3 gets less than or equal to 1/3 of the
 * utility regardless of what player 3 plays.
 * @author maz
 *
 */
public class ExAnteCoreColludable implements GameSet {


  

  /**
   * WARNING: ASSUMES SYMMETRY
   * Tests if there is an action for player 1 and an action for player 2, such that
   * player 3 gets less than or equal to 1/3 of the
   * utility regardless of what player 3 plays.
   *
   */
  @Override
  public boolean contains(ThreePlayerGame g) {
    int[] numActions = g.getNumActions();
    for(int i=0;i<numActions[0];i++){
      for(int j=0;j<numActions[1];j++){
        if (dominate(i,j,numActions[2],g)){
          return true;
        }
      }
    }
    return false;
  }

  /**
   * Tests if player 1 plays i and player 2 plays j, then player 3 gets less than or equal to 1/3 of the
   * utility regardless of what player 3 plays.
   * @param i action for player 1
   * @param j action for player 2
   * @param numActions number of actions for the third player.
   * @param g game being played.
   * @return
   */
  private boolean dominate(int i, int j, int numActions,ThreePlayerGame g) {
    for(int k=0;k<numActions;k++){
      int[] util = g.getUtility(i,j,k);
      if (util[0]+util[1]<util[2]*2){
        return false;
      }
    }
    return true;
  }

}
