package analysis;
import java.util.Random;


public class LocationGameGenerator implements GameGeneratorInterface{
  
  
  public double[][] generateMetric(Random r, int numActions){
    double[][] metric = new double[numActions][numActions];
    
    for(int i=0;i<numActions;i++){
      for(int j=i+1;j<numActions;j++){
        metric[i][j]=r.nextInt(1000)+1;
        metric[j][i]=metric[i][j];
      }
    }
    return metric;
  }
  
  public int[] getPeople(Random r, int numActions){
    int[] people = new int[numActions];
    for(int i=0;i<people.length;i++){
      people[i]=(1+r.nextInt(3))*6;
    }
    return people;
  }
  
  public ThreePlayerGame generateGame(double[][] metric, int[] people){
    int numActions = people.length;
    ThreePlayerGame g = new ThreePlayerGame(numActions);

    for(int i=0;i<numActions;i++){
      for(int j=0;j<numActions;j++){
        for(int k=0;k<numActions;k++){
          setUtility(g,i,j,k,people,metric);
        }
        
      }
      
    }
    return g;
    
  }
  
  @Override
  public ThreePlayerGame generateGame(Random r, int numActions) {
    double[][] metric = generateMetric(r,numActions);
    
    int[] people = getPeople(r,numActions);
    return generateGame(metric,people);
  }

  private void setUtility(ThreePlayerGame g, int i, int j, int k, int[] people, double[][] metric) {
    int[] values = g.getUtility(i, j, k);
    values[0]=values[1]=values[2]=0;
    for(int person=0;person<people.length;person++){
      int numPerson = people[person];
      double distI = metric[i][person];
      
      double distJ = metric[j][person];
      double distK = metric[k][person];
      if (distI<distJ){
        if (distK<distI){
          // distK<distI<distJ
          values[2]+=numPerson;
        } else if (distI<distK){
          // distI<distK,distI<distJ
          values[0]+=numPerson;
        } else {
          // distI==distK<distJ
          values[0]=numPerson/2;
          values[2]=numPerson/2;
        }
      } else if (distJ<distI){
        if (distK<distJ){
          // distK<distJ<distI
          values[2]+=numPerson;
        } else if (distJ<distK){
          // distJ<distK,distI<distK
          values[1]+=numPerson;
        } else {
          // distK=distJ<distI          
          values[1]=numPerson/2;
          values[2]=numPerson/2;
        }
        
      } else {
        // distI==distJ
        if (distK<distJ){
          // distK<distJ==distI
          values[2]+=numPerson;
        } else if (distJ<distK){
          // distJ==distI<distK
          values[0]+=numPerson/2;
          values[1]+=numPerson/2;
        } else {
          // distK==distJ==distI          
          values[0]=numPerson/3;
          values[1]=numPerson/3;
          values[2]=numPerson/3;
        }
        
      }
    }
    
  }

  
}
