package com.yahoo.lsg.correlatedresults;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import results.TripleResults;

public class DetailedResults extends TripleResults{
  long[][] detailedResults;
  
  public Map<String,DetailedRandomVariable> getDetailedRandomVariables(){
    Map<String,DetailedRandomVariable> result = new Hashtable<String,DetailedRandomVariable>();
    for(int index=0;index<playerNames.length;index++){
      DetailedRandomVariable variable = new DetailedRandomVariable();
      for(int i=0;i<detailedResults.length;i++){
        variable.addSample(detailedResults[i][index]);
      }
      result.put(playerNames[index], variable);
    }
    return result;
  }
  
  public DetailedResults(ArrayList<String> detailLines, String names, String totals, String squares){
    super(names,totals,squares,detailLines.size());
    detailedResults = new long[detailLines.size()][];
    for(int i=0;i<detailedResults.length;i++){
      String[] tokens = detailLines.get(i).split(" ");
      detailedResults[i]=new long[tokens.length];
      for(int j=0;j<tokens.length;j++){
        detailedResults[i][j]=Long.parseLong(tokens[j]);
      }
    }
  }
  
  public static List<DetailedResults> getDetailedResults(File file) throws IOException{
    BufferedReader reader = new BufferedReader(new FileReader(file));
    List<DetailedResults> allresults = new ArrayList<DetailedResults>();
    while(true){
      DetailedResults results = DetailedResults.read(reader);
      if (results==null){
        break;
      }
      allresults.add(results);
    }
    reader.close();
    return allresults;
  }

  public static DetailedResults read(BufferedReader reader) throws IOException{
    ArrayList<String> detailLines=new ArrayList<String>();
    String line=null;
    while(true){
      line = reader.readLine();
      if (line==null){
        if (detailLines.size()==0){
          return null;
        }
        throw new IOException("Unexpected end of file");
      }
      char c = line.charAt(0);
      if (Character.isDigit(c)){
        detailLines.add(line);
      } else {
        break;
      }
    }
    String names = line;
    String totals = reader.readLine();
    String squares = reader.readLine();
    return new DetailedResults(detailLines,names,totals,squares);
  }
  
}
