package com.yahoo.lsg.correlatedresults;

import java.util.Hashtable;
import java.util.Map;
import java.util.Set;


public abstract class DictionarySummation<T,V> {
  public abstract V getDefault();
  
  public DictionarySummation(){
    data = new Hashtable<T,V>();
  }
  
  Hashtable<T,V> data;
  public V get(T key){
    if (data.containsKey(key)){
      return data.get(key);
    }
    return getDefault();
  }
  
  
  public abstract V add(V original, V increment);
  public void add(T key,V amount){
    V before = get(key);
    V after = add(before,amount);
    data.put(key, after);
  }
  
  public void addAll(Set<Map.Entry<T,V>> entries){
    for(Map.Entry<T,V> entry:entries){
      add(entry.getKey(),entry.getValue());
    }
  }
  
  public void addAll(Map<T,V> map){
    addAll(map.entrySet());
  }
  
  public void addAll(DictionarySummation<T,V> map){
    addAll(map.entrySet());
  }
  
  public Set<Map.Entry<T, V>> entrySet(){
    return data.entrySet();
  }
}
