package com.yahoo.lsg.correlatedresults;

public class StudentDistribution {
  
  public static double getCoefficient(int nu){
    double initial;
    if (nu % 2==0){
      initial = 1.0/(2.0*Math.sqrt(nu));
    } else {
      initial = 1.0/(Math.PI * Math.sqrt(nu));
    }
    for(int i=nu-1;i>1;i-=2){
      initial *= (i/(i-1));
    }
    return initial;
  }
  
  public static double density(int nu, double t){
    double c = getCoefficient(nu);
    double base = 1.0+((t*t)/nu);
    double power = -(1.0+nu)/2;
    return c * Math.pow(base,power);
    
  }
  
  public static double normalDensity(double x){
    double coefficient = 1.0/Math.sqrt(2.0*Math.PI);
    double power = -(x*x)/2.0;
    return coefficient*Math.exp(power);
  }
  
  public static void main(String[] args){
    int[] nus = new int[]{5,6,7,8,9,10,11,12,1000,1001,10000,10001,100000,1000*1000};
    for(int nu:nus){
      //System.out.println("Coefficient("+nu+"):"+getCoefficient(nu));
      System.out.println("Density("+nu+"):"+density(nu,1.0));
    }
    System.out.println("Density(infty):"+normalDensity(1.0));
  }
}
