package com.yahoo.lsg.lifelong.examples;

import game.Game;

import java.util.Random;

import com.yahoo.lsg.lifelong.GameInformation;
import com.yahoo.lsg.lifelong.LifelongStrategy;

public class ConstantLifelongStrategy implements LifelongStrategy{
  int nextAction;
  Random random;
  
  public ConstantLifelongStrategy(GameInformation info, long seed, String options){
    random = new Random(seed);
    nextAction = -1;
  }
  
  @Override
  public int getAction() {
    return nextAction;
  }
  
  @Override
  public void newGame(Game g, int iterations) {
    if (nextAction<0 || nextAction>=g.getNumActions(0)){
      nextAction = random.nextInt(g.getNumActions(0));
    }
  }
  
  @Override
  public void observeOutcome(int[] actions) {
  }
  
}
