package com.yahoo.lsg.lifelong.observer;

import java.util.Arrays;

import com.yahoo.lsg.lifelong.GameInformation;
import com.yahoo.lsg.lifelong.PlayerIdentity;

public class UtilityObserver extends PlayerFocusedObserver {

  
  private static PlayerObserver[] getPlayerObservers(PlayerIdentity[] identities){
    PlayerObserver[] observers = new PlayerObserver[identities.length];
    for(int i=0;i<observers.length;i++){
      observers[i]=new PlayerUtilityObserver(identities[i]);
    }
    return observers;
  }
  public UtilityObserver(GameInformation info,
      PlayerIdentity... identities) {
    super(getPlayerObservers(identities), info, identities);
    
  }

  public void display(){
    PlayerUtilityObserver[] recordsCopy=new PlayerUtilityObserver[observers.length];
    
    for(int i=0;i<recordsCopy.length;i++){
      recordsCopy[i]=(PlayerUtilityObserver)(observers[i]);
    }
    Arrays.sort(recordsCopy);
    
    for(int i=0;i<recordsCopy.length;i++){
      PlayerUtilityObserver record = recordsCopy[i];
      record.display();
      if (i<recordsCopy.length-1){
        System.out.println("\tDifference:"+ (recordsCopy[i+1].lifetimeUtility.getMean()-record.lifetimeUtility.getMean()));
      }
    }

  }
}
