package com.yahoo.lsg.stats.generalized;

import java.util.Arrays;

import game.Game;
import game.GameGenerator;
import stats.SeriesObserver;

public class SameActionsCount implements SeriesObserver{

  int countSame;
  int numRounds;
  int[] lastActions;
  public SameActionsCount(GameGenerator generator){
    lastActions = null;
    countSame = 0;
  }
  
  
  public String toString(){
    return "{\"countSame\":"+countSame+",\"numRounds\":"+numRounds+"}";
  }
  
  public String toString(String[] playerNames){
    String playerString = "[\""+playerNames[0]+"\", \""+playerNames[1]+"\", \""+playerNames[2]+"\"]";
    return "{\"countSame\":"+countSame+",\"numRounds\":"+numRounds+",\"playerNames\":"+playerString+"}";
  }
  
  @Override
  public void display(String[] playerNames) {
    System.out.println(toString(playerNames));
  }

  @Override
  public void finishGame() {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void finishSeries() {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void startGame(Game g) {
    lastActions = null;
    // TODO Auto-generated method stub
    
  }

  public boolean closeEnough(int[] actions){
    if (lastActions==null){
      return false;
    }
    int numEqual = 0;
    for(int i=0;i<actions.length;i++){
      if (lastActions[i]==actions[i]){
        numEqual++;
      }
    }
    return (numEqual>=2);
  }
  
  @Override
  public void observeOutcome(int[] actions) {
    assert(actions.length==3);
    if (closeEnough(actions)){
      countSame++;
    }
    lastActions = Arrays.copyOf(actions,actions.length);
    numRounds++;
  }

}
