package com.yahoo.lsg.sundisplay;

import java.util.Random;

import game.Game;
import game.Strategy;

/**
 * Cycle through actions like a clock.
 * @author maz
 *
 */
public class ClockPlayer implements Strategy {

  int lastAction;
  private final int numActions;
  public ClockPlayer(Game g, long seed, String options){
    this.numActions = g.getNumActions();
    Random r = new Random(seed);
    lastAction = r.nextInt(numActions);
  }
  
  @Override
  public int getAction() {
    lastAction++;
    if (lastAction>=numActions){
      lastAction = 0;
    }
    return lastAction;
  }

  @Override
  public void observeOutcome(int[] actions) {
    
  }

}
