package com.yahoo.lsg.sundisplay;

import javax.swing.JFrame;
import javax.swing.Timer;

import stats.SeriesObserver;
import game.Game;
import game.GameGenerator;
import game.Utility;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Arrays;

public class SunObserver implements SeriesObserver,ActionListener{
  SunDisplay display;
  SunModel model;
  JFrame frame;
  long sunriseTime;
  Timer t;
  Utility util;
  String[] names;
  int[] lastActions;
  
  public SunObserver(GameGenerator g, String[] names){
    this.names = names;
  }
  @Override
  public void display(String[] playerNames) {
  }

  @Override
  public void finishGame() {
    frame.setVisible(false);
    frame.dispose();
    frame = null;
    model = null;
    display = null;
    lastActions = null;
    try{
    Thread.sleep(LENGTH_OF_DAY);
    } catch (InterruptedException e){
      
    }
  }

  @Override
  public void finishSeries() {
    //frame.setVisible(false);
  }

  @Override
  public void startGame(Game g) {
    model=new SunModel(3);
    display=new SunDisplay(g,names);
    util = g.getUtility();
    frame=new JFrame("Lemonade Stand Game");
    frame.add(display);
    frame.pack();
    frame.validate();
    frame.setVisible(true);
    model.addListener(display);
  }

  
  @Override
  public void observeOutcome(int[] actions) {
    System.out.println(Arrays.toString(actions));
    try{
      
      if (t!=null && t.isRunning()){
        t.stop();
      }
    SunModelData data = new SunModelData(3);
    model.lockAndGetModel(data);
    for(int i=0;i<actions.length;i++){
      if (lastActions!=null){
        data.setPieceOld(i, lastActions[i]);
      } else {
        data.setPieceOld(i, actions[i]);
      }
      data.setPiece(i, actions[i]);
    }
    data.setVisibleAll(true);
    data.utilitiesVisible = true;
    data.setTimeOfDay(0);
    int[] utilChange = util.getUtility(actions);
    for(int i=0;i<3;i++){
      data.scores[i]+=utilChange[i];
    }
    model.setModelAndUnlock(data);
    sunriseTime = System.currentTimeMillis();
    if (lastActions!=null && Arrays.equals(lastActions,actions)){
      LENGTH_OF_DAY=1000;
    } else {
      LENGTH_OF_DAY=2000;
    }
    lastActions = Arrays.copyOf(actions, 3);
    t = new Timer(20, this);
    t.start();
    
    
    Thread.sleep(LENGTH_OF_DAY);
    } catch (InterruptedException ie){
      // Not a real error, just continue
    }
  }

  int LENGTH_OF_DAY = 2000;
  @Override
  public void actionPerformed(ActionEvent e) {
    
    if (model==null){
      t.stop();
      return;
    }
    long currentTime = System.currentTimeMillis();
    double timeOfDay = ((double)(currentTime - sunriseTime))/LENGTH_OF_DAY;
    if (timeOfDay>1.0){
      timeOfDay = 1.0;
      t.stop();
    }
    try{
      SunModelData data = new SunModelData(3);
      model.lockAndGetModel(data);
      data.setTimeOfDay(timeOfDay);
      model.setModelAndUnlock(data);
    } catch (InterruptedException ie){
      // Not a real error, just continue
    }
  }
  
}
