package game;


/**
 * An interface representing the utility function of a game.
 * Utilities are integers instead of doubles so there are
 * no issues with representation.
 * @author maz
 *
 */
public interface Utility {
  /**
   * Constructs a new array and places the utilities in it.
   * @param actions the actions taken by a player.
   * @return the resulting utilities.
   */
  public int[] getUtility(int[] actions);

  
  /**
   * Copies the utility into an existing array.
   * @param actions the actions taken by a player
   * @param result the resulting utilities.
   */
  public void getUtility(int[] actions, int[] result);
  
  public boolean isSymmetric();
  
  public Utility swapPlayers(int i, int j);
}
