package lemonade;

import game.Utility;

public abstract class AbstractLocationGameUtility implements LocationGameUtility{

  int numActions;
  
  public AbstractLocationGameUtility(int numActions){
    this.numActions = numActions;
    
  }
  
  
  
  /**
   * Note: I will try and speed this up later with a memoization step.
   */
  @Override
  public int[] getUtility(int[] actions) {
    int[] result = new int[actions.length];
    getUtility(actions,result);
    return result;
  }

  @Override
  public void getUtility(int[] actions, int[] result) {
    assert(actions.length==result.length);
    for(int i=0;i<result.length;i++){
      result[i]=0;
    }
    int[] distance = new int[actions.length];
    for(int currentPosition = 0;currentPosition<numActions;currentPosition++){
      int currentConsumers = getNumConsumers(currentPosition);
      for(int player=0;player<actions.length;player++){
        distance[player]=getDistance(actions[player],currentPosition);

      }

      
      // The minimum distance of any user
      int minDistance = distance[0];
      // The number of users at the minimum distance
      int minDistanceCount = 1;
      for(int player=1;player<actions.length;player++){
        if (distance[player]<minDistance){
          minDistance = distance[player];
          minDistanceCount = 1;
        } else if (distance[player]==minDistance){
          minDistanceCount++;
        }
      }
      // At this point, the minDistance and minDistanceCount are correct.
      for(int player=0;player<actions.length;player++){
        if (distance[player]==minDistance){
          result[player]+=currentConsumers/minDistanceCount;
        }
      }
      
      
      
    }
    
  }

  @Override
  public boolean isSymmetric() {
    return true;
  }

  @Override
  public Utility swapPlayers(int i, int j) {
    return this;
  }


}
