package results;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Hashtable;
import java.util.Vector;


public class CrossTableDisplay {
  
  public static String[] removeOneString(String[] names, int indexToMove){
    String[] shortList = new String[names.length-1];
    for(int i=0;i<indexToMove;i++){
      shortList[i]=names[i];
    }
    for(int i=indexToMove;i<shortList.length;i++){
      shortList[i]=names[i+1];
    }
    return shortList;
  }
  
  public static void displayCrossTable(Vector <TripleResults> results, String[] names, int principalIndex, String filename) throws IOException{
    String[] shortList = removeOneString(names,principalIndex);
    CrossTable table = new CrossTable(names[principalIndex],shortList,results);
    FileOutputStream fos = new FileOutputStream(filename);
    PrintStream out = new PrintStream(fos);
    table.display(out);
    fos.close();
  }
  
  public static void displayPairTable(Vector <TripleResults> results, String[] names, String filename) throws IOException{
    PairTable table = new PairTable(names,results);
    FileOutputStream fos = new FileOutputStream(filename);
    PrintStream out = new PrintStream(fos);
    table.display(out);
    fos.close();
  }
  
  
  public static void main(String[] args) throws IOException{
    File file = new File("cleantournamentPart2and3.txt");
    File mappingFile = new File("mapping.txt");
    CrossTable.scale = 18000;
    Vector<TripleResults> results = TripleResults.getResultsWithVariance(file,30);
    Hashtable<String,String> mapping = new Hashtable<String,String>();
    TripleResults.loadHashtable(mappingFile, mapping);
    TripleResults.translate(results, mapping);
    
    String[] names = CalculateTotals.getRankedNames(results);
    
    for(int i=0;i<names.length;i++){
      displayCrossTable(results,names,i,"result"+names[i]+".html");
    }
    
    displayPairTable(results,names,"resultpairs.html");
  }
}
