package stats;

import game.Utility;

import java.util.Map;

import util.Array;


/**
 * An extension of JointActionCounter that displays the utilities
 * instead of the counts.
 * 
 * 
 * @author maz
 *
 */
public class JointActionUtility extends JointActionCounter{
  Utility utility;
  public JointActionUtility(Utility utility){
    this.utility = utility; 
  }
  
  
  /**
   * Display the utilities.
   */
  public void display(){
    System.out.println("Joint Actions:");
    for(Map.Entry<JointAction,Integer> entry:counts.entrySet()){
      int[] utilities = utility.getUtility(entry.getKey().actions);
      
      System.out.println(entry.getKey()+":"+Array.arrayToString(utilities)+":"+entry.getValue());
    }
  }
}
