package stats;

import game.Game;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.IntBuffer;
import java.nio.channels.FileChannel;


public class ReplayObserver implements SeriesObserver{
  ByteBuffer byteBuffer;
  
  IntBuffer headerIntBuffer;
  ByteBuffer headerByteBuffer;
  int index;
  int gameLength;
  int repeats;
  int numActions;
  public ReplayObserver(Game g){
    byteBuffer = ByteBuffer.allocate(g.getNumPlayers()*100*100);
    headerByteBuffer = ByteBuffer.allocate(5*4);
    headerIntBuffer = headerByteBuffer.asIntBuffer(); 
    index = 0;
    gameLength = 0;
    repeats = 0;
    numActions = 0;
  }
  
  static int version = 1;
  static File storage = new File("results"+File.separatorChar+"storage");
  @Override
  public void display(String[] playerNames) {
    try{
    String filename = playerNames[0]+"_"+playerNames[1]+"_"+playerNames[2]+".ser";
    File f = new File(storage,filename);
    FileOutputStream fos = new FileOutputStream(f);
    FileChannel channel = fos.getChannel();
    byteBuffer.flip();
    
    headerIntBuffer.put(version);
    headerIntBuffer.put(index);
    headerIntBuffer.put(gameLength);
    headerIntBuffer.put(repeats);
    headerIntBuffer.put(numActions);
    headerIntBuffer.flip();
    channel.write(headerByteBuffer);
    channel.write(byteBuffer);
    channel.close();
    fos.close();
    
    } catch (IOException io){
      throw new RuntimeException(io);
    }
  }

  @Override
  public void finishGame() {
    // TODO Auto-generated method stub
    if (gameLength==0){
      gameLength=index/numActions;
    }
  }

  @Override
  public void finishSeries() {
    repeats = index/(gameLength*numActions);
  }

  @Override
  public void observeOutcome(int[] actions) {
    if (numActions==0){
      numActions = actions.length;
    }
    for(int i=0;i<actions.length;i++){
      byteBuffer.put((byte)actions[i]);
    }
    index+=actions.length;
  }

  @Override
  public void startGame(Game g) {
    // TODO Auto-generated method stub
    
  }
  
  
}

