package stats.collusion;

import game.Game;


/**
 * An observer of utility, like jointactionutility, that does
 * not keep track of joint actions, simply utilities.
 * @author maz
 *
 */
public class CollusionObserver extends AbstractCollusionObserver{
  
  
  
  int collusionsStarted;
  int collusionsBroken;
  int totalCollusionLength;
  
  
  
  
  
  
  
  
  public void observeStartCollusion(){
    this.collusionsStarted++;
    this.totalCollusionLength++;
  }
  
  
  
  public CollusionObserver(Game g){
    this();
  }
  /**
   * Construct a utility observer.
   * @param utility a utility function to be used.
   * @param numPlayers the number of players in the game.
   */
  public CollusionObserver(){
  }
  
  
  
  public void observeTerminateCollusion(boolean countBroken){
    int collusionLength = this.currentRound - this.roundCollusionStarted;
    if (this.collusionDidNotCount()){
      // A one-round collusion doesn't count
      collusionsStarted--;
      totalCollusionLength-=collusionLength;
    } else if (countBroken){
      collusionsBroken++;
    }
  }
  
  public void observeContinueCollusion(){
    this.totalCollusionLength++;
  }
  
  
  
  public int getCollusionsStarted(){
    return collusionsStarted;
  }
  
  public int getCollusionsBroken(){
    return collusionsBroken;
  }
  
  public int getTotalCollusionLength(){
    return totalCollusionLength;
  }
  
  /**
   * Display the utilities for the series and the squares of the utilities.
   */
  public void display(String[] names) {
    System.out.println("Collusions started:"+collusionsStarted);
    System.out.println("Collusions broken:"+collusionsBroken);
    System.out.println("Total collusion length:"+totalCollusionLength);
    
  }



  @Override
  public void startGame(Game g) {
    // TODO Auto-generated method stub
    
  }
  


}
