package strategy;

import game.Game;
import game.Strategy;

import java.util.Random;


/**
 * A strategy that plays an action chosen uniformly and independently
 * at random each round.
 * 
 * @author maz
 *
 */
public class UniformStrategy implements Strategy{
  /**
   * The number of actions available in the game.
   */
  int numActions;
  
  /**
   * A random number generator for the random actions.
   */
  Random r;
  public UniformStrategy(Game g, long seed, String options) {
    this.numActions = g.getNumActions();
    this.r = new Random(seed);
  }
  



  public int getAction() {
    return r.nextInt(numActions);
  }

  public void observeOutcome(int[] actions) {
  }
  
  
  
}
