package com.yahoo.lsg.correlatedresults;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;


public class DetailedRandomVariableTest {
  long [] uniform;
  DetailedRandomVariable drv;
  DetailedRandomVariable drv2;

  @Before
  public void setUp() throws Exception {
    uniform = new long[]{0,1,2,3,4,5,6,7,8,9}; 
    drv = new DetailedRandomVariable();
    drv2 = new DetailedRandomVariable();
    for(long sample:uniform){
      drv.addSample(sample);
      drv2.addSample(sample);
    }
  }

  @After
  public void tearDown() throws Exception {
  }

  @Test
  public void testAddSample() {
    assertEquals(uniform.length,drv.count);
  }

  @Test
  public void testGetMean() {
    assertEquals(4.5,drv.getMean(),0.0);
  }

  @Test
  public void testGetStandardErrorOfTheMean() {
    // TODO this is not the actual standard error. Need a simpler test in
    // this case.
    double stderr=drv.getStandardErrorOfTheMean();
    
    
    assertEquals(0.957,stderr,0.001);

  }

  @Test
  public void testGetStandardErrorOfTheMean2() {
    // TODO this is not the actual standard error. Need a simpler test in
    // this case.
    drv.addSamples(drv2);
    drv.addSamples(drv2);
    drv.addSamples(drv2);
    double stderr=drv.getStandardErrorOfTheMean();
    
    
    assertEquals(0.459,stderr,0.01);
  }
  
  

  @Test
  public void testDetailedRandomVariable() {
    assertNotNull(drv);
  }

  @Test
  public void testAddSamplesDetailedRandomVariable() {
    drv.addSamples(drv2);
    assertEquals(20,drv.count);
    assertEquals(4.5,drv.getMean(),0.0);
    
    
  }

  @Test
  public void testOpposite() {
    DetailedRandomVariable drvOpp = drv.opposite();
    assertEquals(10,drvOpp.count);
    assertEquals(-4.5,drvOpp.getMean(),0.0);
  }

  @Test
  public void testSum() {
    DetailedRandomVariable drvSum = drv.sum(drv2);
    assertEquals(10,drvSum.count);
    assertEquals(9.0,drvSum.getMean(),0.0);
  }

  @Test
  public void testDifference() {
    DetailedRandomVariable drvDifference = drv.difference(drv2);
    assertEquals(10,drvDifference.count);
    assertEquals(0.0,drvDifference.getMean(),0.0);
  }

}
