package com.yahoo.lsg.correlatedresults;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.Map;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;


public class DetailedResultsTest {

  DetailedResults dr;
  
  @Before
  public void setUp() throws Exception {
    ArrayList<String> details = new ArrayList<String>();
    for(int i=0;i<10;i++){
      details.add("10 20 30");
    }
    String names = "A B C";
    String totals = "100 200 300";
    String totalsSquared = "1000 4000 9000";
    
    dr = new DetailedResults(details, names, totals, totalsSquared);
  }

  @After
  public void tearDown() throws Exception {
    dr = null;
  }

  @Test
  public void testGetDetailedRandomVariables() {
    Map<String,DetailedRandomVariable> vars = dr.getDetailedRandomVariables();
    DetailedRandomVariable drvA = vars.get("A");
    DetailedRandomVariable drvB = vars.get("B");
    assertEquals(10.0,drvA.getMean(),0.0);
    assertEquals(20.0,drvB.getMean(),0.0);
    
  }

  @Test
  public void testDetailedResults() {
    assertNotNull(dr);
  }
}
