package com.yahoo.lsg.correlatedresults;

import static org.junit.Assert.*;

import java.util.Map;
import java.util.Set;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;


public class LongSummationTest {

  LongSummation<String> summation;
  @Before
  public void setUp() throws Exception {
    summation = new LongSummation<String>();
  }

  @After
  public void tearDown() throws Exception {
  }

  @Test
  public void testLongSummation() {
    assertNotNull(summation);
  }

  @Test
  public void testGet() {
    long value = summation.get("EMPTY");
    assertEquals(0,value);
  }

  @Test
  public void testAdd() {
    summation.add("X",3);
    long x  = summation.get("X");
    assertEquals(3,x);
    
  }

  @Test
  public void testAdd2() {
    summation.add("X",3);
    summation.add("X",4);
    long x  = summation.get("X");
    assertEquals(7,x);
  }

  @Test
  public void testEntrySet() {
    summation.add("X",3);
    summation.add("Y",4);
    summation.add("Z",5);
    Set<Map.Entry<String,Long>> set = summation.entrySet();
    for(Map.Entry<String, Long> entry:set){
      if (entry.getKey().equals("X")){
        assertEquals(3,(long)(entry.getValue()));
      } else if (entry.getKey().equals("Y")){
        assertEquals(4,(long)(entry.getValue()));
      } else if (entry.getKey().equals("Z")){
        assertEquals(5,(long)(entry.getValue()));
      } else {
        fail("Unrecognized key:"+entry.getKey());
      }
    }
  }

}
