package com.yahoo.lsg.correlatedresults;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;


public class RandomVariableTest {

  long [] uniform;
  RandomVariable drv;
  RandomVariable drv2;

  @Before
  public void setUp() throws Exception {
    uniform = new long[]{0,1,2,3,4,5,6,7,8,9}; 
    drv = new DetailedRandomVariable();
    drv2 = new DetailedRandomVariable();
    for(long sample:uniform){
      drv.addSample(sample);
      drv2.addSample(sample);
    }
  }

  @After
  public void tearDown() throws Exception {
  }

  @Test
  public void testAddSample() {
    assertEquals(uniform.length,drv.count);
  }

  @Test
  public void testGetMean() {
    assertEquals(4.5,drv.getMean(),0.0);
  }

  @Test
  public void testGetStandardErrorOfTheMean() {
    // TODO this is not the actual standard error. Need a simpler test in
    // this case.
    double stderr=drv.getStandardErrorOfTheMean();
    
    
    assertEquals(0.957,stderr,0.001);

  }

  @Test
  public void testErf(){
    double x = RandomVariable.erf(0.0);
    assertEquals(0.0,x,0.0);
  }
  
  @Test
  public void testErf2(){
    double x = RandomVariable.erf(0.05);
    assertEquals(0.0563,x,0.0001);
  }

  @Test
  public void testErf3(){
    double x = RandomVariable.erf(1.0);
    assertEquals(0.8427008,x,0.0001);
  }

  @Test
  public void testErf4(){
    double x = RandomVariable.erf(2.0);
    assertEquals(0.9953223,x,0.0001);
  }

  @Test
  public void testErf40(){
    double x = RandomVariable.erf(4.0);
    assertEquals(1.0,x,0.0001);
  }


  @Test
  public void testErf45(){
    double x = RandomVariable.erf(4.5);
    assertEquals(1.0,x,0.0001);
  }

  @Test
  public void testErf5(){
    double x = RandomVariable.erf(5.0);
    assertEquals(1.0,x,0.0001);
  }



  @Test
  public void testErf55(){
    double x = RandomVariable.erf(5.5);
    assertEquals(1.0,x,0.0001);
  }

/*
  @Test
  public void testErf6(){
    double x = RandomVariable.erf(6.0);
    assertEquals(1.0,x,0.0001);
  }


  @Test
  public void testErf7(){
    double x = RandomVariable.erf(7.0);
    assertEquals(1.0,x,0.0001);
  }

  @Test
  public void testErf9(){
    double x = RandomVariable.erf(9.0);
    assertEquals(1.0,x,0.0001);
  }
*/
}
