#!/usr/bin/perl

use strict;
use warnings;



open(SOURCE, "<", "source.sh");

my @sourceLines = <SOURCE>;

close(SOURCE);

my $svnlocation = "svn+dreamhost://mzinkevi\@zinkevich.org/home/mzinkevi/svn/Code/LSG/LSG2012";

my $new_version = $ARGV[0];
my $old_version = "UNKNOWN";
for my $i (0..$#sourceLines){
  if ($sourceLines[$i] =~ /^export LSG_VERSION=(.*)$/){
    $old_version = $1;
    $sourceLines[$i]="export LSG_VERSION=".$new_version."\n";
  }
}

system("svn status > error.txt");
open(SVNERROR,"<","error.txt");
my @svnstatus = <SVNERROR>;

foreach my $line (@svnstatus){
  print "Status issue:".$line;
}
print "Number of issues:".($#svnstatus+1)."\n";

if ($#svnstatus>=0){
  print "Uncommitted changes. Aborting...\n";
  exit(0);
}

if ($new_version eq ""){
  print "No new version specified\n";
  exit(0);
}

if ($old_version eq ""){
  print "No old version\n";
  exit(0);
}

print "Old version:".$old_version."\n";
print "New version:".$new_version."\n";


open(SOURCE2,">","source.sh");
foreach my $line (@sourceLines){
  print SOURCE2 $line;
}
close(SOURCE2);

system("svn commit -m \"Update to version $new_version\"");

my $moveCommand = "svn mv ".$svnlocation."/lemonade".$old_version." ".$svnlocation."/lemonade".$new_version;
system($moveCommand);

system("svn update");
print "Update from version ".$old_version." to version ".$new_version."\n";




