/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.ualberta.rggibson;

/**
 *
 * @author Richard
 */
public abstract class BehaviourModel
{
    final double DECAY = 0.8;

    double count;
    double maxCount;
    double weight;

    public BehaviourModel()
    {
        count = 0.0;
        maxCount = 0.0;
        weight = 0.0;
    }

    public double getWeight()
    {
        if (isAvailable())
        {
            return weight;
        }

        return 0.0;
    }

    public abstract String getName();

    public abstract int[] getActionList();

    public abstract boolean isAvailable();

    public abstract void update(int[] actions, boolean doUpdateCounts);

    @Override
    public abstract BehaviourModel clone();
}
