/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.ualberta.rggibson;
import java.util.ArrayList;

/**
 *
 * @author Richard
 */
public class BehaviourMystery extends BehaviourModel
{
    int player;
    int numActions;
    BehaviourModel[] bms;

    int[] actions;

    public BehaviourMystery(int player, int numActions, ArrayList<BehaviourModel> bms)
    {
        super();
        
        this.player = player;
        this.numActions = numActions;
        if (bms != null)
        {
            this.bms = new BehaviourModel[bms.size()];
            for (int m = 0; m < this.bms.length; ++m)
            {
                this.bms[m] = bms.get(m);
            }
        }
        else
        {
            this.bms = null;
        }

        actions = null;
    }

    public String getName()
    {
        return "Mystery";
    }

    public int[] getActionList()
    {
        assert(actions != null);
        return actions;
    }

    public boolean isAvailable()
    {
        if (actions != null)
        {
            return true;
        }

        return false;
    }

    public void setBehaviourModels(BehaviourModel[] bms, int numModels)
    {
        assert(this.bms == null);
        this.bms = new BehaviourModel[numModels];
        for (int m = 0; m < numModels; ++m)
        {
            this.bms[m] = bms[m];
        }
    }

    public void update(int[] actions, boolean doUpdateCounts)
    {
        // Update counts and weight
        if (doUpdateCounts && isAvailable())
        {
            count *= DECAY;
            maxCount *= DECAY;

            for (int a : this.actions)
            {
                if (actions[player] == a)
                {
                    count += 1;
                    break;
                }
            }
            maxCount += 1;

            weight = count / maxCount;
        }

        // Update action list
        boolean[] actionFlags = new boolean[numActions]; // Initialized to false
        int numMysteryActions = numActions;
        assert(bms != null);
        for (int i = 0; i < bms.length; ++i)
        {
            BehaviourModel bm = bms[i];

            if (bm.isAvailable())
            {
                int[] behaviourActions = bms[i].getActionList();
                for (int a : behaviourActions)
                {
                    if (!actionFlags[a])
                    {
                        actionFlags[a] = true;
                        --numMysteryActions;
                    }
                }
            }
        }

        if (numMysteryActions == 0)
        {
            this.actions = null;
        }
        else
        {
            this.actions = new int[numMysteryActions];
            int i = 0;
            for (int a = 0; a < numActions; ++a)
            {
                if (!actionFlags[a])
                {
                    this.actions[i++] = a;
                }
            }
        }
    }

    public BehaviourModel clone()
    {
        // Set bms to null and require user to call setBehaviourModels()
        BehaviourMystery bm = new BehaviourMystery(player, numActions, null);

        bm.count = count;
        bm.maxCount = maxCount;
        bm.weight = weight;
        if (actions != null)
        {
            bm.actions = new int[actions.length];
            for (int i = 0; i < actions.length; ++i)
            {
                bm.actions[i] = actions[i];
            }
        }

        return bm;
    }
}
