/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.ualberta.rggibson;
import game.Utility;

/**
 *
 * @author Richard
 */
public class BehaviourSandwich extends BehaviourModel
{
    int player;
    int target;
    int numActions;
    Utility util;

    int[] nextAction;

    public BehaviourSandwich(int numActions, int player, int target, Utility util)
    {
        super();

        this.numActions = numActions;
        this.player = player;
        this.target = target;
        this.util = util;

        nextAction = null;
    }

    public String getName()
    {
        String name = "Sandwich";
        if (target == 0)
        {
            name += "Me";
        }
        else
        {
            name += "Opp";
        }

        return name;
    }

    public int[] getActionList()
    {
        assert (isAvailable());
        return nextAction;
    }

    public boolean isAvailable()
    {
        return (nextAction == null ? false : true);
    }

    public void update(int[] actions, boolean doUpdateCounts)
    {
        // Update the counts and weight
        if (doUpdateCounts && isAvailable())
        {
            count *= DECAY;
            maxCount *= DECAY;

            for (int a : nextAction)
            {
                if (actions[player] == a)
                {
                    count += 1;
                    break;
                }
            }
            maxCount += 1;

            weight = count / maxCount;
        }

        // Update the next action
        int sandwichLowerAction = UctBehaviourModeller.mod(actions[target] - 1, numActions);
        int sandwichHigherAction = UctBehaviourModeller.mod(actions[target] + 1, numActions);
        int[] testActionProfile = {actions[0], actions[1], actions[2]};
        testActionProfile[player] = sandwichLowerAction;
        int sandwichLowerTargetUtil = util.getUtility(testActionProfile)[target];
        testActionProfile[player] = sandwichHigherAction;
        int sandwichHigherTargetUtil = util.getUtility(testActionProfile)[target];

        if (sandwichHigherTargetUtil < sandwichLowerTargetUtil)
        {
            nextAction = new int[1];
            nextAction[0] = sandwichHigherAction;
        }
        else if (sandwichHigherTargetUtil == sandwichLowerTargetUtil)
        {
            nextAction = new int[2];
            nextAction[0] = sandwichLowerAction;
            nextAction[1] = sandwichHigherAction;
        }
        else
        {
            nextAction = new int[1];
            nextAction[0] = sandwichLowerAction;
        }
    }

    public BehaviourModel clone()
    {
        BehaviourSandwich bm = new BehaviourSandwich(numActions, player, target, util);

        bm.count = count;
        bm.maxCount = maxCount;
        bm.weight = weight;
        bm.nextAction = new int[nextAction.length];
        for (int a = 0; a < nextAction.length; ++a)
        {
            bm.nextAction[a] = nextAction[a];
        }
        
        return bm;
    }
}
